// GENERATED CODE - DO NOT MODIFY BY HAND
// This code was generated by ObjectBox. To update it run the generator again:
// With a Flutter package, run `flutter pub run build_runner build`.
// With a Dart package, run `dart run build_runner build`.
// See also https://docs.objectbox.io/getting-started#generate-objectbox-code

// ignore_for_file: camel_case_types, depend_on_referenced_packages
// coverage:ignore-file

import 'dart:typed_data';

import 'package:flat_buffers/flat_buffers.dart' as fb;
import 'package:objectbox/internal.dart'; // generated code can access "internal" functionality
import 'package:objectbox/objectbox.dart';
import 'package:objectbox_flutter_libs/objectbox_flutter_libs.dart';

import 'models/beer_model.dart';

export 'package:objectbox/objectbox.dart'; // so that callers only have to import this file

final _entities = <ModelEntity>[
  ModelEntity(
      id: const IdUid(7, 2125772677534088609),
      name: 'BeerModel',
      lastPropertyId: const IdUid(8, 3779695725962415436),
      flags: 0,
      properties: <ModelProperty>[
        ModelProperty(
            id: const IdUid(1, 1156599032004901447),
            name: 'id',
            type: 6,
            flags: 1),
        ModelProperty(
            id: const IdUid(2, 1832378482449135713),
            name: 'name',
            type: 9,
            flags: 34848,
            indexId: const IdUid(4, 1992408373130253159)),
        ModelProperty(
            id: const IdUid(6, 8012964860954562990),
            name: 'imageUrl',
            type: 9,
            flags: 0),
        ModelProperty(
            id: const IdUid(7, 3263618601193434372),
            name: 'tagline',
            type: 9,
            flags: 0),
        ModelProperty(
            id: const IdUid(8, 3779695725962415436),
            name: 'description',
            type: 9,
            flags: 0)
      ],
      relations: <ModelRelation>[],
      backlinks: <ModelBacklink>[])
];

/// Shortcut for [Store.new] that passes [getObjectBoxModel] and for Flutter
/// apps by default a [directory] using `defaultStoreDirectory()` from the
/// ObjectBox Flutter library.
///
/// Note: for desktop apps it is recommended to specify a unique [directory].
///
/// See [Store.new] for an explanation of all parameters.
Future<Store> openStore(
        {String? directory,
        int? maxDBSizeInKB,
        int? fileMode,
        int? maxReaders,
        bool queriesCaseSensitiveDefault = true,
        String? macosApplicationGroup}) async =>
    Store(getObjectBoxModel(),
        directory: directory ?? (await defaultStoreDirectory()).path,
        maxDBSizeInKB: maxDBSizeInKB,
        fileMode: fileMode,
        maxReaders: maxReaders,
        queriesCaseSensitiveDefault: queriesCaseSensitiveDefault,
        macosApplicationGroup: macosApplicationGroup);

/// Returns the ObjectBox model definition for this project for use with
/// [Store.new].
ModelDefinition getObjectBoxModel() {
  final model = ModelInfo(
      entities: _entities,
      lastEntityId: const IdUid(7, 2125772677534088609),
      lastIndexId: const IdUid(4, 1992408373130253159),
      lastRelationId: const IdUid(0, 0),
      lastSequenceId: const IdUid(0, 0),
      retiredEntityUids: const [
        8098175984369316275,
        2221658186616122228,
        2983371026491801001,
        51631135309772613,
        3905955379404508749,
        6768179977075030629
      ],
      retiredIndexUids: const [],
      retiredPropertyUids: const [
        2875305218321426066,
        9054214573377822945,
        1861812330805356690,
        1047694566017626678,
        2586399506754364507,
        1198100885464982535,
        888354731354626917,
        6119889321655726834,
        8406067030425736856,
        2507282086199465149,
        5392838533458034144,
        9099326635007017205,
        1821056349320323122,
        3708234101261366375,
        7093647548584657256,
        2583420038446887088,
        3415122692760069779,
        553901654525374941,
        5796872980125773190,
        737310828727896604,
        6049718047443838537,
        4012503527951587262,
        647135461659277108,
        3599890956582001148,
        3687819091067015471,
        3421473118341020063,
        3181420890742021169,
        6733346764577875666,
        4668823257989191098
      ],
      retiredRelationUids: const [],
      modelVersion: 5,
      modelVersionParserMinimum: 5,
      version: 1);

  final bindings = <Type, EntityDefinition>{
    BeerModel: EntityDefinition<BeerModel>(
        model: _entities[0],
        toOneRelations: (BeerModel object) => [],
        toManyRelations: (BeerModel object) => {},
        getId: (BeerModel object) => object.id,
        setId: (BeerModel object, int id) {
          object.id = id;
        },
        objectToFB: (BeerModel object, fb.Builder fbb) {
          final nameOffset = fbb.writeString(object.name);
          final imageUrlOffset = fbb.writeString(object.imageUrl);
          final taglineOffset = fbb.writeString(object.tagline);
          final descriptionOffset = fbb.writeString(object.description);
          fbb.startTable(9);
          fbb.addInt64(0, object.id);
          fbb.addOffset(1, nameOffset);
          fbb.addOffset(5, imageUrlOffset);
          fbb.addOffset(6, taglineOffset);
          fbb.addOffset(7, descriptionOffset);
          fbb.finish(fbb.endTable());
          return object.id;
        },
        objectFromFB: (Store store, ByteData fbData) {
          final buffer = fb.BufferContext(fbData);
          final rootOffset = buffer.derefObject(0);
          final idParam =
              const fb.Int64Reader().vTableGet(buffer, rootOffset, 4, 0);
          final nameParam = const fb.StringReader(asciiOptimization: true)
              .vTableGet(buffer, rootOffset, 6, '');
          final imageUrlParam = const fb.StringReader(asciiOptimization: true)
              .vTableGet(buffer, rootOffset, 14, '');
          final taglineParam = const fb.StringReader(asciiOptimization: true)
              .vTableGet(buffer, rootOffset, 16, '');
          final descriptionParam =
              const fb.StringReader(asciiOptimization: true)
                  .vTableGet(buffer, rootOffset, 18, '');
          final object = BeerModel(
              id: idParam,
              name: nameParam,
              imageUrl: imageUrlParam,
              tagline: taglineParam,
              description: descriptionParam);

          return object;
        })
  };

  return ModelDefinition(model, bindings);
}

/// [BeerModel] entity fields to define ObjectBox queries.
class BeerModel_ {
  /// see [BeerModel.id]
  static final id = QueryIntegerProperty<BeerModel>(_entities[0].properties[0]);

  /// see [BeerModel.name]
  static final name =
      QueryStringProperty<BeerModel>(_entities[0].properties[1]);

  /// see [BeerModel.imageUrl]
  static final imageUrl =
      QueryStringProperty<BeerModel>(_entities[0].properties[2]);

  /// see [BeerModel.tagline]
  static final tagline =
      QueryStringProperty<BeerModel>(_entities[0].properties[3]);

  /// see [BeerModel.description]
  static final description =
      QueryStringProperty<BeerModel>(_entities[0].properties[4]);
}
